Index: .bzrignore
===================================================================
--- .bzrignore	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
+++ .bzrignore	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -0,0 +1,265 @@
+*.disasm
+*.map
+*.prev
+Makefile.depend
+Makefile.common
+Makefile.config
+autotool/
+common.h
+config.h
+hdisk.img
+image.iso
+boot/distroot/
+boot/initrd.img
+kernel/kernel.bin
+kernel/kernel.dump
+kernel/kernel.raw
+kernel/arch/amd64/_link.ld
+kernel/arch/amd64/include/arch/common.h
+kernel/generic/src/debug/real_map.bin
+uspace/app/bdsh/bdsh
+uspace/app/bithenge/bithenge
+uspace/app/blkdump/blkdump
+uspace/app/bnchmark/bnchmark
+uspace/app/date/date
+uspace/app/devctl/devctl
+uspace/app/dnscfg/dnscfg
+uspace/app/dnsres/dnsres
+uspace/app/edit/edit
+uspace/app/getterm/getterm
+uspace/app/inet/inet
+uspace/app/init/init
+uspace/app/kill/kill
+uspace/app/killall/killall
+uspace/app/klog/klog
+uspace/app/loc/loc
+uspace/app/logset/logset
+uspace/app/mixerctl/mixerctl
+uspace/app/mkbd/mkbd
+uspace/app/mkexfat/mkexfat
+uspace/app/mkfat/mkfat
+uspace/app/mkmfs/mkmfs
+uspace/app/netecho/netecho
+uspace/app/nettest1/nettest1
+uspace/app/nettest2/nettest2
+uspace/app/nettest3/nettest3
+uspace/app/nterm/nterm
+uspace/app/ping/ping
+uspace/app/ping6/ping6
+uspace/app/redir/redir
+uspace/app/sbi/sbi
+uspace/app/sportdmp/sportdmp
+uspace/app/stats/stats
+uspace/app/sysinfo/sysinfo
+uspace/app/taskdump/taskdump
+uspace/app/tester/tester
+uspace/app/testread/testread
+uspace/app/testwrit/testwrit
+uspace/app/tetris/tetris
+uspace/app/top/top
+uspace/app/trace/trace
+uspace/app/usbinfo/usbinfo
+uspace/app/vdemo/vdemo
+uspace/app/vlaunch/images.c
+uspace/app/vlaunch/images.h
+uspace/app/vlaunch/vlaunch
+uspace/app/vterm/vterm
+uspace/app/vuhid/vuh
+uspace/app/wavplay/wavplay
+uspace/app/websrv/websrv
+uspace/dist/app/bdsh
+uspace/dist/app/bithenge
+uspace/dist/app/blkdump
+uspace/dist/app/bnchmark
+uspace/dist/app/date
+uspace/dist/app/devctl
+uspace/dist/app/dnscfg
+uspace/dist/app/dnsres
+uspace/dist/app/edit
+uspace/dist/app/getterm
+uspace/dist/app/inet
+uspace/dist/app/kill
+uspace/dist/app/killall
+uspace/dist/app/klog
+uspace/dist/app/loc
+uspace/dist/app/logset
+uspace/dist/app/mixerctl
+uspace/dist/app/mkbd
+uspace/dist/app/mkexfat
+uspace/dist/app/mkfat
+uspace/dist/app/mkmfs
+uspace/dist/app/netecho
+uspace/dist/app/nettest1
+uspace/dist/app/nettest2
+uspace/dist/app/nettest3
+uspace/dist/app/nterm
+uspace/dist/app/ping
+uspace/dist/app/ping6
+uspace/dist/app/redir
+uspace/dist/app/sbi
+uspace/dist/app/sportdmp
+uspace/dist/app/stats
+uspace/dist/app/sysinfo
+uspace/dist/app/taskdump
+uspace/dist/app/tester
+uspace/dist/app/testread
+uspace/dist/app/testwrit
+uspace/dist/app/tetris
+uspace/dist/app/top
+uspace/dist/app/trace
+uspace/dist/app/usbinfo
+uspace/dist/app/vdemo
+uspace/dist/app/vlaunch
+uspace/dist/app/vterm
+uspace/dist/app/vuh
+uspace/dist/app/wavplay
+uspace/dist/app/websrv
+uspace/dist/drv/ahci/
+uspace/dist/drv/ata_bd/
+uspace/dist/drv/cmos-rtc/
+uspace/dist/drv/e1k/
+uspace/dist/drv/ehci/
+uspace/dist/drv/i8042/
+uspace/dist/drv/isa/
+uspace/dist/drv/kfb/
+uspace/dist/drv/ne2k/
+uspace/dist/drv/ns8250/
+uspace/dist/drv/ohci/
+uspace/dist/drv/pciintel/
+uspace/dist/drv/ps2mouse/
+uspace/dist/drv/root/
+uspace/dist/drv/rootpc/
+uspace/dist/drv/rootvirt/
+uspace/dist/drv/rtl8139/
+uspace/dist/drv/sb16/
+uspace/dist/drv/test1/
+uspace/dist/drv/test2/
+uspace/dist/drv/test3/
+uspace/dist/drv/uhci/
+uspace/dist/drv/uhcirh/
+uspace/dist/drv/usbflbk/
+uspace/dist/drv/usbhid/
+uspace/dist/drv/usbhub/
+uspace/dist/drv/usbmast/
+uspace/dist/drv/usbmid/
+uspace/dist/drv/vhc/
+uspace/dist/drv/xtkbd/
+uspace/dist/srv/apic
+uspace/dist/srv/cdfs
+uspace/dist/srv/clipboard
+uspace/dist/srv/compositor
+uspace/dist/srv/console
+uspace/dist/srv/devman
+uspace/dist/srv/dnsrsrv
+uspace/dist/srv/ethip
+uspace/dist/srv/exfat
+uspace/dist/srv/ext4fs
+uspace/dist/srv/fat
+uspace/dist/srv/file_bd
+uspace/dist/srv/g_part
+uspace/dist/srv/hound
+uspace/dist/srv/i8259
+uspace/dist/srv/inetsrv
+uspace/dist/srv/input
+uspace/dist/srv/isdv4_tablet
+uspace/dist/srv/locfs
+uspace/dist/srv/loopip
+uspace/dist/srv/mbr_part
+uspace/dist/srv/mfs
+uspace/dist/srv/output
+uspace/dist/srv/remcons
+uspace/dist/srv/sata_bd
+uspace/dist/srv/slip
+uspace/dist/srv/taskmon
+uspace/dist/srv/tcp
+uspace/dist/srv/tmpfs
+uspace/dist/srv/udf
+uspace/dist/srv/udp
+uspace/drv/audio/sb16/sb16
+uspace/drv/block/ahci/ahci
+uspace/drv/block/ata_bd/ata_bd
+uspace/drv/bus/isa/isa
+uspace/drv/bus/pci/pciintel/pciintel
+uspace/drv/bus/usb/ehci/ehci
+uspace/drv/bus/usb/ohci/ohci
+uspace/drv/bus/usb/uhci/uhci
+uspace/drv/bus/usb/uhcirh/uhcirh
+uspace/drv/bus/usb/usbflbk/usbflbk
+uspace/drv/bus/usb/usbhid/usbhid
+uspace/drv/bus/usb/usbhub/usbhub
+uspace/drv/bus/usb/usbmast/usbmast
+uspace/drv/bus/usb/usbmid/usbmid
+uspace/drv/bus/usb/vhc/vhc
+uspace/drv/char/i8042/i8042
+uspace/drv/char/ns8250/ns8250
+uspace/drv/char/ps2mouse/ps2mouse
+uspace/drv/char/xtkbd/xtkbd
+uspace/drv/fb/kfb/kfb
+uspace/drv/infrastructure/root/root
+uspace/drv/infrastructure/rootpc/rootpc
+uspace/drv/infrastructure/rootvirt/rootvirt
+uspace/drv/nic/e1k/e1k
+uspace/drv/nic/ne2k/ne2k
+uspace/drv/nic/rtl8139/rtl8139
+uspace/drv/test/test1/test1
+uspace/drv/test/test2/test2
+uspace/drv/test/test3/test3
+uspace/drv/time/cmos-rtc/cmos-rtc
+uspace/lib/c/arch/amd64/_link-dlexe.ld
+uspace/lib/c/arch/amd64/_link-loader.ld
+uspace/lib/c/arch/amd64/_link-shlib.ld
+uspace/lib/c/arch/amd64/_link.ld
+uspace/lib/c/arch/amd64/include/libarch/common.h
+uspace/lib/posix/collisions.list
+uspace/lib/posix/redefs-hide-libc.xargs
+uspace/lib/posix/redefs-show-posix.xargs
+uspace/lib/posix/include/libc
+uspace/srv/audio/hound/hound
+uspace/srv/bd/file_bd/file_bd
+uspace/srv/bd/part/guid_part/g_part
+uspace/srv/bd/part/mbr_part/mbr_part
+uspace/srv/bd/rd/rd
+uspace/srv/bd/sata_bd/sata_bd
+uspace/srv/clipboard/clipboard
+uspace/srv/devman/devman
+uspace/srv/fs/cdfs/cdfs
+uspace/srv/fs/exfat/exfat
+uspace/srv/fs/ext4fs/ext4fs
+uspace/srv/fs/fat/fat
+uspace/srv/fs/locfs/locfs
+uspace/srv/fs/mfs/mfs
+uspace/srv/fs/tmpfs/tmpfs
+uspace/srv/fs/udf/udf
+uspace/srv/hid/compositor/compositor
+uspace/srv/hid/compositor/images.c
+uspace/srv/hid/compositor/images.h
+uspace/srv/hid/console/console
+uspace/srv/hid/input/input
+uspace/srv/hid/isdv4_tablet/isdv4_tablet
+uspace/srv/hid/output/output
+uspace/srv/hid/remcons/remcons
+uspace/srv/hid/s3c24xx_ts/s3c24xx_ts
+uspace/srv/hw/char/s3c24xx_uart/s3c24ser
+uspace/srv/hw/irc/apic/apic
+uspace/srv/hw/irc/i8259/i8259
+uspace/srv/loader/loader
+uspace/srv/locsrv/locsrv
+uspace/srv/logger/logger
+uspace/srv/net/dnsrsrv/dnsrsrv
+uspace/srv/net/ethip/ethip
+uspace/srv/net/inetsrv/inetsrv
+uspace/srv/net/loopip/loopip
+uspace/srv/net/slip/slip
+uspace/srv/net/tcp/tcp
+uspace/srv/net/udp/udp
+uspace/srv/ns/ns
+uspace/srv/taskmon/taskmon
+uspace/srv/vfs/vfs
+kernel/arch/ia32/_link.ld
+uspace/lib/c/arch/ia32/_link-dlexe.ld
+uspace/lib/c/arch/ia32/_link-loader.ld
+uspace/lib/c/arch/ia32/_link-shlib.ld
+uspace/lib/c/arch/ia32/_link.ld
+kernel/arch/arm32/_link.ld
+uspace/app/corecfg/corecfg
+uspace/dist/app/corecfg
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ boot/Makefile.common	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -165,4 +165,5 @@
 	$(USPACE_PATH)/app/blkdump/blkdump \
 	$(USPACE_PATH)/app/bnchmark/bnchmark \
+	$(USPACE_PATH)/app/corecfg/corecfg \
 	$(USPACE_PATH)/app/devctl/devctl \
 	$(USPACE_PATH)/app/dltest/dltest \
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ boot/arch/arm32/Makefile.inc	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -57,5 +57,5 @@
 endif
 
-RD_DRVS += \
+RD_DRVS_ESSENTIAL += \
 	infrastructure/rootamdm37x \
 	fb/amdm37x_dispc \
Index: boot/arch/mips32/Makefile.inc
===================================================================
--- boot/arch/mips32/Makefile.inc	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ boot/arch/mips32/Makefile.inc	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -50,4 +50,17 @@
 endif
 
+ifeq ($(MACHINE), $(filter $(MACHINE),bmalta lmalta))
+	RD_DRVS_ESSENTIAL += \
+		infrastructure/rootmalta \
+		block/ata_bd \
+		bus/pci/pciintel \
+		bus/isa \
+		char/i8042 \
+		char/ps2mouse \
+		char/xtkbd
+
+	RD_DRV_CFG += \
+		bus/isa
+endif
 
 SOURCES = \
Index: boot/arch/ppc32/Makefile.inc
===================================================================
--- boot/arch/ppc32/Makefile.inc	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ boot/arch/ppc32/Makefile.inc	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -42,5 +42,5 @@
 	$(USPACE_PATH)/srv/hw/bus/cuda_adb/cuda_adb
 
-RD_DRVS += \
+RD_DRVS_ESSENTIAL += \
 	infrastructure/rootmac \
 	bus/pci/pciintel \
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/Makefile	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -220,5 +220,4 @@
 	generic/src/mm/km.c \
 	generic/src/mm/reserve.c \
-	generic/src/mm/buddy.c \
 	generic/src/mm/frame.c \
 	generic/src/mm/page.c \
Index: kernel/arch/abs32le/include/arch/mm/page.h
===================================================================
--- kernel/arch/abs32le/include/arch/mm/page.h	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/abs32le/include/arch/mm/page.h	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -57,8 +57,8 @@
 
 /* Page table sizes for each level. */
-#define PTL0_SIZE_ARCH  ONE_FRAME
-#define PTL1_SIZE_ARCH  0
-#define PTL2_SIZE_ARCH  0
-#define PTL3_SIZE_ARCH  ONE_FRAME
+#define PTL0_FRAMES_ARCH  1
+#define PTL1_FRAMES_ARCH  1
+#define PTL2_FRAMES_ARCH  1
+#define PTL3_FRAMES_ARCH  1
 
 /* Macros calculating indices for each level. */
Index: kernel/arch/amd64/include/arch/mm/page.h
===================================================================
--- kernel/arch/amd64/include/arch/mm/page.h	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/amd64/include/arch/mm/page.h	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -61,8 +61,8 @@
 
 /* Page table sizes for each level. */
-#define PTL0_SIZE_ARCH  ONE_FRAME
-#define PTL1_SIZE_ARCH  ONE_FRAME
-#define PTL2_SIZE_ARCH  ONE_FRAME
-#define PTL3_SIZE_ARCH  ONE_FRAME
+#define PTL0_FRAMES_ARCH  1
+#define PTL1_FRAMES_ARCH  1
+#define PTL2_FRAMES_ARCH  1
+#define PTL3_FRAMES_ARCH  1
 
 /* Macros calculating indices into page tables in each level. */
Index: kernel/arch/amd64/src/ddi/ddi.c
===================================================================
--- kernel/arch/amd64/src/ddi/ddi.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/amd64/src/ddi/ddi.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -42,4 +42,5 @@
 #include <errno.h>
 #include <arch/cpu.h>
+#include <cpu.h>
 #include <arch.h>
 #include <align.h>
@@ -58,27 +59,28 @@
 int ddi_iospace_enable_arch(task_t *task, uintptr_t ioaddr, size_t size)
 {
-	size_t bits = ioaddr + size;
-	if (bits > IO_PORTS)
+	size_t elements = ioaddr + size;
+	if (elements > IO_PORTS)
 		return ENOENT;
 	
-	if (task->arch.iomap.bits < bits) {
+	if (task->arch.iomap.elements < elements) {
 		/*
 		 * The I/O permission bitmap is too small and needs to be grown.
 		 */
 		
-		uint8_t *newmap = (uint8_t *) malloc(BITS2BYTES(bits), FRAME_ATOMIC);
-		if (!newmap)
+		void *store = malloc(bitmap_size(elements, 0), FRAME_ATOMIC);
+		if (!store)
 			return ENOMEM;
 		
 		bitmap_t oldiomap;
-		bitmap_initialize(&oldiomap, task->arch.iomap.map,
+		bitmap_initialize(&oldiomap, task->arch.iomap.elements, 0,
 		    task->arch.iomap.bits);
-		bitmap_initialize(&task->arch.iomap, newmap, bits);
+		
+		bitmap_initialize(&task->arch.iomap, elements, 0, store);
 		
 		/*
 		 * Mark the new range inaccessible.
 		 */
-		bitmap_set_range(&task->arch.iomap, oldiomap.bits,
-		    bits - oldiomap.bits);
+		bitmap_set_range(&task->arch.iomap, oldiomap.elements,
+		    elements - oldiomap.elements);
 		
 		/*
@@ -88,6 +90,7 @@
 		if (oldiomap.bits) {
 			bitmap_copy(&task->arch.iomap, &oldiomap,
-			    oldiomap.bits);
-			free(oldiomap.map);
+			    oldiomap.elements);
+			
+			free(oldiomap.bits);
 		}
 	}
@@ -96,5 +99,5 @@
 	 * Enable the range and we are done.
 	 */
-	bitmap_clear_range(&task->arch.iomap, (size_t) ioaddr, (size_t) size);
+	bitmap_clear_range(&task->arch.iomap, (size_t) ioaddr, size);
 	
 	/*
@@ -118,13 +121,15 @@
 	/* First, copy the I/O Permission Bitmap. */
 	irq_spinlock_lock(&TASK->lock, false);
+	
 	size_t ver = TASK->arch.iomapver;
-	size_t bits = TASK->arch.iomap.bits;
-	if (bits) {
-		ASSERT(TASK->arch.iomap.map);
+	size_t elements = TASK->arch.iomap.elements;
+	
+	if (elements > 0) {
+		ASSERT(TASK->arch.iomap.bits);
 		
 		bitmap_t iomap;
-		bitmap_initialize(&iomap, CPU->arch.tss->iomap,
-		    TSS_IOMAP_SIZE * 8);
-		bitmap_copy(&iomap, &TASK->arch.iomap, bits);
+		bitmap_initialize(&iomap, TSS_IOMAP_SIZE * 8, 0,
+		    CPU->arch.tss->iomap);
+		bitmap_copy(&iomap, &TASK->arch.iomap, elements);
 		
 		/*
@@ -132,16 +137,19 @@
 		 * I/O access.
 		 */
-		bitmap_set_range(&iomap, bits, ALIGN_UP(bits, 8) - bits);
+		bitmap_set_range(&iomap, elements,
+		    ALIGN_UP(elements, 8) - elements);
+		
 		/*
 		 * It is safe to set the trailing eight bits because of the
 		 * extra convenience byte in TSS_IOMAP_SIZE.
 		 */
-		bitmap_set_range(&iomap, ALIGN_UP(bits, 8), 8);
+		bitmap_set_range(&iomap, ALIGN_UP(elements, 8), 8);
 	}
+	
 	irq_spinlock_unlock(&TASK->lock, false);
 	
 	/*
 	 * Second, adjust TSS segment limit.
-	 * Take the extra ending byte will all bits set into account. 
+	 * Take the extra ending byte with all bits set into account.
 	 */
 	ptr_16_64_t cpugdtr;
@@ -149,5 +157,6 @@
 	
 	descriptor_t *gdt_p = (descriptor_t *) cpugdtr.base;
-	gdt_tss_setlimit(&gdt_p[TSS_DES], TSS_BASIC_SIZE + BITS2BYTES(bits));
+	size_t size = bitmap_size(elements, 0);
+	gdt_tss_setlimit(&gdt_p[TSS_DES], TSS_BASIC_SIZE + size);
 	gdtr_load(&cpugdtr);
 	
Index: kernel/arch/amd64/src/proc/task.c
===================================================================
--- kernel/arch/amd64/src/proc/task.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/amd64/src/proc/task.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -34,6 +34,7 @@
 
 #include <proc/task.h>
+#include <typedefs.h>
+#include <adt/bitmap.h>
 #include <mm/slab.h>
-#include <typedefs.h>
 
 /** Perform amd64 specific task initialization.
@@ -45,5 +46,5 @@
 {
 	task->arch.iomapver = 0;
-	bitmap_initialize(&task->arch.iomap, NULL, 0);
+	bitmap_initialize(&task->arch.iomap, 0, 0, NULL);
 }
 
@@ -55,6 +56,6 @@
 void task_destroy_arch(task_t *task)
 {
-	if (task->arch.iomap.map)
-		free(task->arch.iomap.map);
+	if (task->arch.iomap.bits != NULL)
+		free(task->arch.iomap.bits);
 }
 
Index: kernel/arch/arm32/include/arch/mm/page.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/page.h	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/arm32/include/arch/mm/page.h	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -73,8 +73,8 @@
 
 /* Page table sizes for each level. */
-#define PTL0_SIZE_ARCH          FOUR_FRAMES
-#define PTL1_SIZE_ARCH          0
-#define PTL2_SIZE_ARCH          0
-#define PTL3_SIZE_ARCH          ONE_FRAME
+#define PTL0_FRAMES_ARCH  4
+#define PTL1_FRAMES_ARCH  1
+#define PTL2_FRAMES_ARCH  1
+#define PTL3_FRAMES_ARCH  1
 
 /* Macros calculating indices into page tables for each level. */
Index: kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c
===================================================================
--- kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -60,5 +60,5 @@
 
 static struct beagleboard {
-	amdm37x_irc_regs_t *irc_addr;
+	omap_irc_regs_t *irc_addr;
 	omap_uart_t uart;
 	amdm37x_gpt_t timer;
@@ -103,5 +103,5 @@
 	    PAGE_NOT_CACHEABLE);
 	ASSERT(beagleboard.irc_addr);
-	amdm37x_irc_init(beagleboard.irc_addr);
+	omap_irc_init(beagleboard.irc_addr);
 
 	/* Initialize timer. Use timer1, because it is in WKUP power domain
@@ -123,5 +123,5 @@
 
 	/* Enable timer interrupt */
-	amdm37x_irc_enable(beagleboard.irc_addr, AMDM37x_GPT1_IRQ);
+	omap_irc_enable(beagleboard.irc_addr, AMDM37x_GPT1_IRQ);
 
 	/* Start timer here */
@@ -147,5 +147,5 @@
 static void bbxm_irq_exception(unsigned int exc_no, istate_t *istate)
 {
-	const unsigned inum = amdm37x_irc_inum_get(beagleboard.irc_addr);
+	const unsigned inum = omap_irc_inum_get(beagleboard.irc_addr);
 
 	irq_t *irq = irq_dispatch_and_lock(inum);
@@ -161,5 +161,5 @@
 	/** amdm37x manual ch. 12.5.2 (p. 2428) places irc ack at the end
 	 * of ISR. DO this to avoid strange behavior. */
-	amdm37x_irc_irq_ack(beagleboard.irc_addr);
+	omap_irc_irq_ack(beagleboard.irc_addr);
 }
 
@@ -188,5 +188,5 @@
 		indev_t *srln = srln_wire(srln_instance, sink);
 		omap_uart_input_wire(&beagleboard.uart, srln);
-		amdm37x_irc_enable(beagleboard.irc_addr, AMDM37x_UART3_IRQ);
+		omap_irc_enable(beagleboard.irc_addr, AMDM37x_UART3_IRQ);
 	}
 #endif
Index: kernel/arch/arm32/src/mach/beaglebone/beaglebone.c
===================================================================
--- kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -63,5 +63,5 @@
 
 static struct beaglebone {
-	am335x_irc_regs_t *irc_addr;
+	omap_irc_regs_t *irc_addr;
 	am335x_cm_per_regs_t *cm_per_addr;
 	am335x_cm_dpll_regs_t *cm_dpll_addr;
@@ -104,5 +104,5 @@
 
 	/* Initialize the interrupt controller */
-	am335x_irc_init(bbone.irc_addr);
+	omap_irc_init(bbone.irc_addr);
 }
 
@@ -153,5 +153,5 @@
 	}
 	/* Enable the interrupt */
-	am335x_irc_enable(bbone.irc_addr, AM335x_DMTIMER2_IRQ);
+	omap_irc_enable(bbone.irc_addr, AM335x_DMTIMER2_IRQ);
 	/* Start the timer */
 	am335x_timer_start(&bbone.timer);
@@ -176,5 +176,5 @@
 static void bbone_irq_exception(unsigned int exc_no, istate_t *istate)
 {
-	const unsigned inum = am335x_irc_inum_get(bbone.irc_addr);
+	const unsigned inum = omap_irc_inum_get(bbone.irc_addr);
 
 	irq_t *irq = irq_dispatch_and_lock(inum);
@@ -187,5 +187,5 @@
 	}
 
-	am335x_irc_irq_ack(bbone.irc_addr);
+	omap_irc_irq_ack(bbone.irc_addr);
 }
 
@@ -214,5 +214,5 @@
 		indev_t *srln = srln_wire(srln_instance, sink);
 		omap_uart_input_wire(&bbone.uart, srln);
-		am335x_irc_enable(bbone.irc_addr, AM335x_UART0_IRQ);
+		omap_irc_enable(bbone.irc_addr, AM335x_UART0_IRQ);
 	}
 #endif
Index: kernel/arch/arm32/src/mm/frame.c
===================================================================
--- kernel/arch/arm32/src/mm/frame.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/arm32/src/mm/frame.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -88,7 +88,6 @@
 void boot_page_table_free(void)
 {
-	unsigned int i;
-	for (i = 0; i < BOOT_PAGE_TABLE_SIZE_IN_FRAMES; i++)
-		frame_free(i * FRAME_SIZE + BOOT_PAGE_TABLE_ADDRESS);
+	frame_free(BOOT_PAGE_TABLE_ADDRESS,
+	    BOOT_PAGE_TABLE_SIZE_IN_FRAMES);
 }
 
Index: kernel/arch/arm32/src/mm/page.c
===================================================================
--- kernel/arch/arm32/src/mm/page.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/arm32/src/mm/page.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -69,5 +69,5 @@
 #ifdef HIGH_EXCEPTION_VECTORS
 	/* Create mapping for exception table at high offset */
-	uintptr_t ev_frame = (uintptr_t) frame_alloc(ONE_FRAME, FRAME_NONE);
+	uintptr_t ev_frame = frame_alloc(1, FRAME_NONE, 0);
 	page_mapping_insert(AS_KERNEL, EXC_BASE_ADDRESS, ev_frame, flags);
 #else
Index: kernel/arch/arm32/src/ras.c
===================================================================
--- kernel/arch/arm32/src/ras.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/arm32/src/ras.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -51,13 +51,12 @@
 void ras_init(void)
 {
-	uintptr_t frame;
-
-	frame = (uintptr_t) frame_alloc(ONE_FRAME,
-	    FRAME_ATOMIC | FRAME_HIGHMEM);
+	uintptr_t frame =
+	    frame_alloc(1, FRAME_ATOMIC | FRAME_HIGHMEM, 0);
 	if (!frame)
-		frame = (uintptr_t) frame_alloc(ONE_FRAME, FRAME_LOWMEM);
+		frame = frame_alloc(1, FRAME_LOWMEM, 0);
+	
 	ras_page = (uintptr_t *) km_map(frame,
 	    PAGE_SIZE, PAGE_READ | PAGE_WRITE | PAGE_USER | PAGE_CACHEABLE);
-
+	
 	memsetb(ras_page, PAGE_SIZE, 0); 
 	ras_page[RAS_START] = 0;
Index: kernel/arch/ia32/include/arch/mm/page.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/page.h	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/ia32/include/arch/mm/page.h	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -66,8 +66,8 @@
 
 /* Page table sizes for each level. */
-#define PTL0_SIZE_ARCH  ONE_FRAME
-#define PTL1_SIZE_ARCH  0
-#define PTL2_SIZE_ARCH  0
-#define PTL3_SIZE_ARCH  ONE_FRAME
+#define PTL0_FRAMES_ARCH  1
+#define PTL1_FRAMES_ARCH  1
+#define PTL2_FRAMES_ARCH  1
+#define PTL3_FRAMES_ARCH  1
 
 /* Macros calculating indices for each level. */
Index: kernel/arch/ia32/src/ddi/ddi.c
===================================================================
--- kernel/arch/ia32/src/ddi/ddi.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/ia32/src/ddi/ddi.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -59,27 +59,28 @@
 int ddi_iospace_enable_arch(task_t *task, uintptr_t ioaddr, size_t size)
 {
-	size_t bits = ioaddr + size;
-	if (bits > IO_PORTS)
+	size_t elements = ioaddr + size;
+	if (elements > IO_PORTS)
 		return ENOENT;
 	
-	if (task->arch.iomap.bits < bits) {
+	if (task->arch.iomap.elements < elements) {
 		/*
 		 * The I/O permission bitmap is too small and needs to be grown.
 		 */
 		
-		uint8_t *newmap = (uint8_t *) malloc(BITS2BYTES(bits), FRAME_ATOMIC);
-		if (!newmap)
+		void *store = malloc(bitmap_size(elements, 0), FRAME_ATOMIC);
+		if (!store)
 			return ENOMEM;
 		
 		bitmap_t oldiomap;
-		bitmap_initialize(&oldiomap, task->arch.iomap.map,
+		bitmap_initialize(&oldiomap, task->arch.iomap.elements, 0,
 		    task->arch.iomap.bits);
-		bitmap_initialize(&task->arch.iomap, newmap, bits);
+		
+		bitmap_initialize(&task->arch.iomap, elements, 0, store);
 		
 		/*
 		 * Mark the new range inaccessible.
 		 */
-		bitmap_set_range(&task->arch.iomap, oldiomap.bits,
-		    bits - oldiomap.bits);
+		bitmap_set_range(&task->arch.iomap, oldiomap.elements,
+		    elements - oldiomap.elements);
 		
 		/*
@@ -89,6 +90,7 @@
 		if (oldiomap.bits) {
 			bitmap_copy(&task->arch.iomap, &oldiomap,
-			    oldiomap.bits);
-			free(oldiomap.map);
+			    oldiomap.elements);
+			
+			free(oldiomap.bits);
 		}
 	}
@@ -97,5 +99,5 @@
 	 * Enable the range and we are done.
 	 */
-	bitmap_clear_range(&task->arch.iomap, (size_t) ioaddr, (size_t) size);
+	bitmap_clear_range(&task->arch.iomap, (size_t) ioaddr, size);
 	
 	/*
@@ -119,13 +121,15 @@
 	/* First, copy the I/O Permission Bitmap. */
 	irq_spinlock_lock(&TASK->lock, false);
+	
 	size_t ver = TASK->arch.iomapver;
-	size_t bits = TASK->arch.iomap.bits;
-	if (bits) {
-		ASSERT(TASK->arch.iomap.map);
+	size_t elements = TASK->arch.iomap.elements;
+	
+	if (elements > 0) {
+		ASSERT(TASK->arch.iomap.bits);
 		
 		bitmap_t iomap;
-		bitmap_initialize(&iomap, CPU->arch.tss->iomap,
-		    TSS_IOMAP_SIZE * 8);
-		bitmap_copy(&iomap, &TASK->arch.iomap, bits);
+		bitmap_initialize(&iomap, TSS_IOMAP_SIZE * 8, 0,
+		    CPU->arch.tss->iomap);
+		bitmap_copy(&iomap, &TASK->arch.iomap, elements);
 		
 		/*
@@ -133,11 +137,14 @@
 		 * I/O access.
 		 */
-		bitmap_set_range(&iomap, bits, ALIGN_UP(bits, 8) - bits);
+		bitmap_set_range(&iomap, elements,
+		    ALIGN_UP(elements, 8) - elements);
+		
 		/*
 		 * It is safe to set the trailing eight bits because of the
 		 * extra convenience byte in TSS_IOMAP_SIZE.
 		 */
-		bitmap_set_range(&iomap, ALIGN_UP(bits, 8), 8);
+		bitmap_set_range(&iomap, ALIGN_UP(elements, 8), 8);
 	}
+	
 	irq_spinlock_unlock(&TASK->lock, false);
 	
@@ -150,5 +157,6 @@
 	
 	descriptor_t *gdt_p = (descriptor_t *) cpugdtr.base;
-	gdt_setlimit(&gdt_p[TSS_DES], TSS_BASIC_SIZE + BITS2BYTES(bits));
+	size_t size = bitmap_size(elements, 0);
+	gdt_setlimit(&gdt_p[TSS_DES], TSS_BASIC_SIZE + size);
 	gdtr_load(&cpugdtr);
 	
Index: kernel/arch/ia32/src/mm/frame.c
===================================================================
--- kernel/arch/ia32/src/mm/frame.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/ia32/src/mm/frame.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -47,5 +47,4 @@
 
 #define PHYSMEM_LIMIT32  UINT64_C(0x100000000)
-#define PHYSMEM_LIMIT_DMA   UINT64_C(0x1000000)
 
 size_t hardcoded_unmapped_ktext_size = 0;
@@ -92,26 +91,11 @@
 				else
 					conf = minconf;
-
-				if ((pfn * PAGE_SIZE) < PHYSMEM_LIMIT_DMA) {
-					size_t dma_count = min(
-					    PHYSMEM_LIMIT_DMA / PAGE_SIZE - pfn,
-					    count);
-					zone_create(pfn, dma_count, conf,
-					    ZONE_AVAILABLE | ZONE_DMA);
-					count -= dma_count;
-					pfn += dma_count;
-				}
-
-				conf = pfn;
-				if (count) {
-					zone_create(pfn, count, conf,
-					    ZONE_AVAILABLE | ZONE_LOWMEM);
-				}
+				zone_create(pfn, count, conf,
+				    ZONE_AVAILABLE | ZONE_LOWMEM);
 			} else {
 				conf = zone_external_conf_alloc(count);
-				if (conf != 0) {
+				if (conf != 0)
 					zone_create(pfn, count, conf,
 					    ZONE_AVAILABLE | ZONE_HIGHMEM);
-				}
 			}
 		} else if ((e820table[i].type == MEMMAP_MEMORY_ACPI) ||
Index: kernel/arch/ia32/src/proc/task.c
===================================================================
--- kernel/arch/ia32/src/proc/task.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/ia32/src/proc/task.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -40,20 +40,22 @@
 /** Perform ia32 specific task initialization.
  *
- * @param t Task to be initialized.
+ * @param task Task to be initialized.
+ *
  */
-void task_create_arch(task_t *t)
+void task_create_arch(task_t *task)
 {
-	t->arch.iomapver = 0;
-	bitmap_initialize(&t->arch.iomap, NULL, 0);
+	task->arch.iomapver = 0;
+	bitmap_initialize(&task->arch.iomap, 0, 0, NULL);
 }
 
 /** Perform ia32 specific task destruction.
  *
- * @param t Task to be initialized.
+ * @param task Task to be initialized.
+ *
  */
-void task_destroy_arch(task_t *t)
+void task_destroy_arch(task_t *task)
 {
-	if (t->arch.iomap.map)
-		free(t->arch.iomap.map);
+	if (task->arch.iomap.bits != NULL)
+		free(task->arch.iomap.bits);
 }
 
Index: kernel/arch/ia64/src/ddi/ddi.c
===================================================================
--- kernel/arch/ia64/src/ddi/ddi.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/ia64/src/ddi/ddi.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -56,11 +56,13 @@
 {
 	if (!task->arch.iomap) {
-		uint8_t *map;
-
 		task->arch.iomap = malloc(sizeof(bitmap_t), 0);
-		map = malloc(BITS2BYTES(IO_MEMMAP_PAGES), 0);
-		if(!map)
+		if (task->arch.iomap == NULL)
 			return ENOMEM;
-		bitmap_initialize(task->arch.iomap, map, IO_MEMMAP_PAGES);
+		
+		void *store = malloc(bitmap_size(IO_MEMMAP_PAGES, 0), 0);
+		if (store == NULL)
+			return ENOMEM;
+		
+		bitmap_initialize(task->arch.iomap, IO_MEMMAP_PAGES, 0, store);
 		bitmap_clear_range(task->arch.iomap, 0, IO_MEMMAP_PAGES);
 	}
@@ -69,5 +71,5 @@
 	size = ALIGN_UP(size + ioaddr - 4 * iopage, PORTS_PER_PAGE);
 	bitmap_set_range(task->arch.iomap, iopage, size / 4);
-
+	
 	return 0;
 }
Index: kernel/arch/ia64/src/mm/vhpt.c
===================================================================
--- kernel/arch/ia64/src/mm/vhpt.c	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/ia64/src/mm/vhpt.c	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -42,8 +42,10 @@
 uintptr_t vhpt_set_up(void)
 {
-	vhpt_base = frame_alloc(VHPT_WIDTH - FRAME_WIDTH,
-	    FRAME_KA | FRAME_ATOMIC);
-	if (!vhpt_base)
+	uintptr_t vhpt_frame =
+	    frame_alloc(SIZE2FRAMES(VHPT_SIZE), FRAME_ATOMIC, 0);
+	if (!vhpt_frame)
 		panic("Kernel configured with VHPT but no memory for table.");
+	
+	vhpt_base = (vhpt_entry_t *) PA2KA(vhpt_frame);
 	vhpt_invalidate_all();
 	return (uintptr_t) vhpt_base;
@@ -82,5 +84,5 @@
 void vhpt_invalidate_all()
 {
-	memsetb(vhpt_base, 1 << VHPT_WIDTH, 0);
+	memsetb(vhpt_base, VHPT_SIZE, 0);
 }
 
Index: kernel/arch/mips32/include/arch/mm/page.h
===================================================================
--- kernel/arch/mips32/include/arch/mm/page.h	(revision 9dbdda91731f77f12ce8c42162b0f95a9b75d72a)
+++ kernel/arch/mips32/include/arch/mm/page.h	(revision 758f8d55da31118ef5accb99051c4f46cc5c880a)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup mips32mm	
+/** @addtogroup mips32mm
  * @{
  */
@@ -70,27 +70,27 @@
  * - PTL3 has 4096 entries (12 bits)
  */
- 
+
 /* Macros describing number of entries in each level. */
-#define PTL0_ENTRIES_ARCH	64
-#define PTL1_ENTRIES_ARCH	0
-#define PTL2_ENTRIES_ARCH	0
-#define PTL3_ENTRIES_ARCH	4096
+#define PTL0_ENTRIES_ARCH  64
+#define PTL1_ENTRIES_ARCH  0
+#define PTL2_ENTRIES_ARCH  0
+#define PTL3_ENTRIES_ARCH  4096
 
 /* Macros describing size of page tables in each level. */
-#define PTL0_SIZE_ARCH		ONE_FRAME
-#define PTL1_SIZE_ARCH		0
-#define PTL2_SIZE_ARCH		0
-#define PTL3_SIZE_ARCH		ONE_FRAME
+#define PTL0_FRAMES_ARCH  1
+#define PTL1_FRAMES_ARCH  1
+#define PTL2_FRAMES_ARCH  1
+#define PTL3_FRAMES_ARCH  1
 
 /* Macros calculating entry indices for each level. */
-#define PTL0_INDEX_ARCH(vaddr)	((vaddr) >> 26) 
-#define PTL1_INDEX_ARCH(vaddr)	0
-#define PTL2_INDEX_ARCH(vaddr)	0
-#define PTL3_INDEX_ARCH(vaddr)	(((vaddr) >> 14) & 0xfff)
+#define PTL0_INDEX_ARCH(vaddr)  ((vaddr) >> 26)
+#define PTL1_INDEX_ARCH(vaddr)  0
+#define PTL2_INDEX_ARCH(vaddr)  0
+#define PTL3_INDEX_ARCH(vaddr)  (((vaddr) >> 14) & 0xfff)
 
 /* Set accessor for PTL0 address. */
 #define SET_PTL0_ADDRESS_ARCH(ptl0)
 
-/* Get PTE address accessors for each level. */ 
+/* Get PTE address accessors for each level. */
 #define GET_PTL1_ADDRESS_ARCH(ptl0, i) \
 	(((pte_t *) (ptl0))[(i)].pfn << 12)
@@ -196,5 +196,4 @@
 	p->p = 1;
 }
-	
 
 extern void page_arch_init(void);
